{
    "$graph": [
        {
            "class": "CommandLineTool",
            "id": "#fastqc.cwl",
            "baseCommand": [
                "fastqc"
            ],
            "inputs": [
                {
                    "id": "#fastqc.cwl/fastqc/input",
                    "type": "File",
                    "inputBinding": {
                        "position": 1
                    }
                }
            ],
            "label": "fastqc",
            "arguments": [
                {
                    "position": 0,
                    "prefix": "-o",
                    "valueFrom": "output"
                }
            ],
            "requirements": [
                {
                    "class": "DockerRequirement",
                    "dockerImageId": "quay.io/biocontainers/fastqc:0.11.8--1",
                    "dockerPull": "quay.io/biocontainers/fastqc:0.11.8--1"
                },
                {
                    "class": "InitialWorkDirRequirement",
                    "listing": [
                        {
                            "entryname": "output",
                            "entry": "$({class: 'Directory'})",
                            "writable": true
                        }
                    ]
                },
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "outputs": [
                {
                    "id": "#fastqc.cwl/fastqc/output",
                    "type": "Directory",
                    "outputBinding": {
                        "glob": "output"
                    }
                }
            ]
        },
        {
            "class": "CommandLineTool",
            "id": "#head.cwl",
            "baseCommand": [
                "head"
            ],
            "inputs": [
                {
                    "id": "#head.cwl/head/count",
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "position": 0,
                        "prefix": "-n"
                    }
                },
                {
                    "id": "#head.cwl/head/input",
                    "type": "File",
                    "inputBinding": {
                        "position": 0
                    }
                }
            ],
            "outputs": [
                {
                    "id": "#head.cwl/head/output",
                    "type": "File",
                    "outputBinding": {
                        "glob": "output"
                    }
                }
            ],
            "label": "head",
            "requirements": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "bash:5.0.2"
                }
            ],
            "stdout": "output"
        },
        {
            "class": "CommandLineTool",
            "id": "#mash_dist.cwl",
            "baseCommand": [
                "mash",
                "dist"
            ],
            "inputs": [
                {
                    "id": "#mash_dist.cwl/mash_dist/reference",
                    "type": "File",
                    "inputBinding": {
                        "position": 0
                    }
                },
                {
                    "id": "#mash_dist.cwl/mash_dist/query",
                    "type": "File",
                    "inputBinding": {
                        "position": 1
                    }
                }
            ],
            "outputs": [
                {
                    "id": "#mash_dist.cwl/mash_dist/output",
                    "type": "File",
                    "outputBinding": {
                        "glob": "output"
                    }
                }
            ],
            "label": "mash_dist",
            "arguments": [
                {
                    "position": 0,
                    "prefix": "-v",
                    "valueFrom": "1.0"
                },
                {
                    "position": 0,
                    "prefix": "-d",
                    "valueFrom": "1.0"
                }
            ],
            "requirements": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "quay.io/biocontainers/mash:2.1--hf69f6b5_1",
                    "dockerImageId": "quay.io/biocontainers/mash:2.1--hf69f6b5_1"
                },
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "stdout": "output"
        },
        {
            "class": "CommandLineTool",
            "id": "#mash_sketch.cwl",
            "baseCommand": [
                "mash",
                "sketch"
            ],
            "inputs": [
                {
                    "id": "#mash_sketch.cwl/mash_sketch/R1",
                    "type": "File",
                    "inputBinding": {
                        "position": 0,
                        "prefix": "-r"
                    }
                },
                {
                    "id": "#mash_sketch.cwl/mash_sketch/R2",
                    "type": "File",
                    "inputBinding": {
                        "position": 0
                    }
                }
            ],
            "outputs": [
                {
                    "id": "#mash_sketch.cwl/mash_sketch/output",
                    "type": "File",
                    "outputBinding": {
                        "glob": "output.msh"
                    }
                }
            ],
            "label": "mash_sketch",
            "arguments": [
                {
                    "position": 0,
                    "prefix": "-k",
                    "valueFrom": "32"
                },
                {
                    "position": 0,
                    "prefix": "-s",
                    "valueFrom": "1000"
                },
                {
                    "position": 0,
                    "prefix": "-m",
                    "valueFrom": "2"
                },
                {
                    "position": 0,
                    "prefix": "-o",
                    "valueFrom": "output"
                }
            ],
            "requirements": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "quay.io/biocontainers/mash:2.1--hf69f6b5_1",
                    "dockerImageId": "quay.io/biocontainers/mash:2.1--hf69f6b5_1"
                }
            ]
        },
        {
            "class": "CommandLineTool",
            "id": "#mlst.cwl",
            "baseCommand": [
                "mlst"
            ],
            "inputs": [
                {
                    "id": "#mlst.cwl/mlst/input",
                    "type": "File",
                    "inputBinding": {
                        "position": 0
                    }
                }
            ],
            "outputs": [
                {
                    "id": "#mlst.cwl/mlst/output",
                    "type": "File",
                    "outputBinding": {
                        "glob": "output"
                    }
                }
            ],
            "label": "mlst",
            "requirements": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "quay.io/biocontainers/mlst:2.16.1--0",
                    "dockerImageId": "quay.io/biocontainers/mlst:2.16.1--0"
                },
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "stdout": "output"
        },
        {
            "class": "CommandLineTool",
            "id": "#quast.cwl",
            "baseCommand": [
                "quast"
            ],
            "inputs": [
                {
                    "id": "#quast.cwl/quast/contigs",
                    "type": "File",
                    "inputBinding": {
                        "position": 1
                    }
                },
                {
                    "id": "#quast.cwl/quast/reference",
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "position": 0,
                        "prefix": "-r"
                    }
                }
            ],
            "outputs": [
                {
                    "id": "#quast.cwl/quast/output",
                    "type": "Directory",
                    "outputBinding": {
                        "glob": "output"
                    }
                }
            ],
            "label": "quast",
            "arguments": [
                {
                    "position": 1,
                    "prefix": "-o",
                    "valueFrom": "output"
                }
            ],
            "requirements": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "quay.io/biocontainers/quast:5.0.2--py27pl526ha92aebf_0",
                    "dockerImageId": "quay.io/biocontainers/quast:5.0.2--py27pl526ha92aebf_0"
                },
                {
                    "class": "InlineJavascriptRequirement"
                }
            ]
        },
        {
            "class": "CommandLineTool",
            "id": "#shovill.cwl",
            "baseCommand": [
                "shovill"
            ],
            "inputs": [
                {
                    "id": "#shovill.cwl/shovill/reads1",
                    "type": "File",
                    "inputBinding": {
                        "position": 0,
                        "prefix": "--R1"
                    }
                },
                {
                    "id": "#shovill.cwl/shovill/reads2",
                    "type": "File",
                    "inputBinding": {
                        "position": 0,
                        "prefix": "--R2"
                    }
                }
            ],
            "outputs": [
                {
                    "id": "#shovill.cwl/shovill/contigs",
                    "type": "File",
                    "outputBinding": {
                        "glob": "outdir/contigs.fa"
                    }
                },
                {
                    "id": "#shovill.cwl/shovill/contig-graph",
                    "type": "File",
                    "outputBinding": {
                        "glob": "outdir/contigs.gfa"
                    }
                },
                {
                    "id": "#shovill.cwl/shovill/log",
                    "type": "File",
                    "outputBinding": {
                        "glob": "outdir/shovill.log"
                    }
                }
            ],
            "label": "shovill",
            "arguments": [
                {
                    "position": 0,
                    "prefix": "--ram",
                    "valueFrom": "$(runtime.ram / 1024)"
                },
                {
                    "position": 0,
                    "prefix": "--outdir",
                    "valueFrom": "outdir"
                }
            ],
            "requirements": [
                {
                    "class": "ResourceRequirement",
                    "ramMin": 4096,
                    "coresMin": 8
                },
                {
                    "class": "DockerRequirement",
                    "dockerPull": "quay.io/biocontainers/shovill:1.0.1--0"
                },
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "hints": [
                {
                    "packages": [
                        {
                            "specs": [
                                "https://identifiers.org/rrid/RRID:SCR_017077"
                            ],
                            "version": [
                                "1.0.1"
                            ],
                            "package": "shovill"
                        }
                    ],
                    "class": "SoftwareRequirement"
                }
            ]
        },
        {
            "class": "CommandLineTool",
            "id": "#sort.cwl",
            "baseCommand": [
                "sort"
            ],
            "inputs": [
                {
                    "id": "#sort.cwl/sort/input",
                    "type": "File",
                    "inputBinding": {
                        "position": 1
                    }
                },
                {
                    "id": "#sort.cwl/sort/keydef",
                    "type": "string",
                    "inputBinding": {
                        "position": 0,
                        "prefix": "-k"
                    }
                },
                {
                    "id": "#sort.cwl/sort/general-numeric-sort",
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 0,
                        "prefix": "-g"
                    }
                }
            ],
            "outputs": [
                {
                    "id": "#sort.cwl/sort/output",
                    "type": "File",
                    "outputBinding": {
                        "glob": "output"
                    }
                }
            ],
            "label": "sort",
            "requirements": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "bash:5.0.2"
                }
            ],
            "stdout": "output"
        },
        {
            "class": "Workflow",
            "id": "#main",
            "label": "cpo-pipeline",
            "inputs": [
                {
                    "id": "#main/reads2",
                    "type": "File",
                    "format": "http://edamontology.org/format_1932"
                },
                {
                    "id": "#main/reads1",
                    "type": "File",
                    "format": "http://edamontology.org/format_1932"
                },
                {
                    "id": "#main/refseq_genomes_k21_s1000_msh",
                    "type": "File"
                }
            ],
            "outputs": [
                {
                    "id": "#main/mlst_output",
                    "outputSource": "#main/mlst/output",
                    "type": "File"
                },
                {
                    "id": "#main/fastqc_R1_output",
                    "outputSource": "#main/fastqc_reads1/output",
                    "type": "Directory"
                },
                {
                    "id": "#main/fastqc_R2_output",
                    "outputSource": "#main/fastqc_reads2/output",
                    "type": "Directory"
                },
                {
                    "id": "#main/quast_output",
                    "outputSource": "#main/quast/output",
                    "type": "Directory"
                },
                {
                    "id": "#main/mash_dist_output",
                    "outputSource": "#main/head/output",
                    "type": "File"
                }
            ],
            "steps": [
                {
                    "id": "#main/shovill",
                    "in": [
                        {
                            "id": "#main/shovill/reads1",
                            "source": "#main/reads1"
                        },
                        {
                            "id": "#main/shovill/reads2",
                            "source": "#main/reads2"
                        }
                    ],
                    "out": [
                        {
                            "id": "#main/shovill/contigs"
                        },
                        {
                            "id": "#main/shovill/contig-graph"
                        },
                        {
                            "id": "#main/shovill/log"
                        }
                    ],
                    "run": "#shovill.cwl",
                    "label": "shovill"
                },
                {
                    "id": "#main/mlst",
                    "in": [
                        {
                            "id": "#main/mlst/input",
                            "source": "#main/shovill/contigs"
                        }
                    ],
                    "out": [
                        {
                            "id": "#main/mlst/output"
                        }
                    ],
                    "run": "#mlst.cwl",
                    "label": "mlst"
                },
                {
                    "id": "#main/quast",
                    "in": [
                        {
                            "id": "#main/quast/contigs",
                            "source": [
                                "#main/shovill/contigs"
                            ]
                        }
                    ],
                    "out": [
                        {
                            "id": "#main/quast/output"
                        }
                    ],
                    "run": "#quast.cwl",
                    "label": "quast"
                },
                {
                    "id": "#main/mash_dist",
                    "in": [
                        {
                            "id": "#main/mash_dist/reference",
                            "source": "#main/refseq_genomes_k21_s1000_msh"
                        },
                        {
                            "id": "#main/mash_dist/query",
                            "source": [
                                "#main/mash_sketch/output"
                            ]
                        }
                    ],
                    "out": [
                        {
                            "id": "#main/mash_dist/output"
                        }
                    ],
                    "run": "#mash_dist.cwl",
                    "label": "mash_dist"
                },
                {
                    "id": "#main/mash_sketch",
                    "in": [
                        {
                            "id": "#main/mash_sketch/R1",
                            "source": "#main/reads1"
                        },
                        {
                            "id": "#main/mash_sketch/R2",
                            "source": "#main/reads2"
                        }
                    ],
                    "out": [
                        {
                            "id": "#main/mash_sketch/output"
                        }
                    ],
                    "run": "#mash_sketch.cwl",
                    "label": "mash_sketch"
                },
                {
                    "id": "#main/sort",
                    "in": [
                        {
                            "id": "#main/sort/input",
                            "source": "#main/mash_dist/output"
                        },
                        {
                            "id": "#main/sort/keydef",
                            "default": "2,2"
                        },
                        {
                            "id": "#main/sort/general-numeric-sort",
                            "default": true
                        }
                    ],
                    "out": [
                        {
                            "id": "#main/sort/output"
                        }
                    ],
                    "run": "#sort.cwl",
                    "label": "sort"
                },
                {
                    "id": "#main/fastqc_reads1",
                    "in": [
                        {
                            "id": "#main/fastqc_reads1/input",
                            "source": [
                                "#main/reads1"
                            ]
                        }
                    ],
                    "out": [
                        {
                            "id": "#main/fastqc_reads1/output"
                        }
                    ],
                    "run": "#fastqc.cwl",
                    "label": "fastqc"
                },
                {
                    "id": "#main/fastqc_reads2",
                    "in": [
                        {
                            "id": "#main/fastqc_reads2/input",
                            "source": [
                                "#main/reads2"
                            ]
                        }
                    ],
                    "out": [
                        {
                            "id": "#main/fastqc_reads2/output"
                        }
                    ],
                    "run": "#fastqc.cwl",
                    "label": "fastqc"
                },
                {
                    "id": "#main/head",
                    "in": [
                        {
                            "id": "#main/head/count",
                            "default": 1
                        },
                        {
                            "id": "#main/head/input",
                            "source": "#main/sort/output"
                        }
                    ],
                    "out": [
                        {
                            "id": "#main/head/output"
                        }
                    ],
                    "run": "#head.cwl",
                    "label": "head"
                }
            ]
        }
    ],
    "cwlVersion": "v1.0",
    "$schemas": [
        "http://edamontology.org/EDAM_1.16.owl"
    ],
    "$namespaces": {
        "edam": "http://edamontology.org/",
        "s": "https://schema.org/"
    }
}
